# coding: utf-8

"""
    The Plaid API

    The Plaid REST API. Please see https://plaid.com/docs/api for more details.  # noqa: E501

    The version of the OpenAPI document: 2020-09-14_1.0.11
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from plaid.generated_plaid.configuration import Configuration


class BankTransferUser(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'legal_name': 'str',
        'email': 'str',
        'routing_number': 'str'
    }

    attribute_map = {
        'legal_name': 'legal_name',
        'email': 'email',
        'routing_number': 'routing_number'
    }

    def __init__(self, legal_name=None, email=None, routing_number=None, local_vars_configuration=None):  # noqa: E501
        """BankTransferUser - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._legal_name = None
        self._email = None
        self._routing_number = None
        self.discriminator = None

        self.legal_name = legal_name
        self.email = email
        if routing_number is not None:
            self.routing_number = routing_number

    @property
    def legal_name(self):
        """Gets the legal_name of this BankTransferUser.  # noqa: E501

        The account holder’s full legal name.  # noqa: E501

        :return: The legal_name of this BankTransferUser.  # noqa: E501
        :rtype: str
        """
        return self._legal_name

    @legal_name.setter
    def legal_name(self, legal_name):
        """Sets the legal_name of this BankTransferUser.

        The account holder’s full legal name.  # noqa: E501

        :param legal_name: The legal_name of this BankTransferUser.  # noqa: E501
        :type legal_name: str
        """
        if self.local_vars_configuration.client_side_validation and legal_name is None:  # noqa: E501
            raise ValueError("Invalid value for `legal_name`, must not be `None`")  # noqa: E501

        self._legal_name = legal_name

    @property
    def email(self):
        """Gets the email of this BankTransferUser.  # noqa: E501

        The account holder’s email.  # noqa: E501

        :return: The email of this BankTransferUser.  # noqa: E501
        :rtype: str
        """
        return self._email

    @email.setter
    def email(self, email):
        """Sets the email of this BankTransferUser.

        The account holder’s email.  # noqa: E501

        :param email: The email of this BankTransferUser.  # noqa: E501
        :type email: str
        """

        self._email = email

    @property
    def routing_number(self):
        """Gets the routing_number of this BankTransferUser.  # noqa: E501

        The account holder's routing number. This field is only used for response data. Do not provide this field when making requests.  # noqa: E501

        :return: The routing_number of this BankTransferUser.  # noqa: E501
        :rtype: str
        """
        return self._routing_number

    @routing_number.setter
    def routing_number(self, routing_number):
        """Sets the routing_number of this BankTransferUser.

        The account holder's routing number. This field is only used for response data. Do not provide this field when making requests.  # noqa: E501

        :param routing_number: The routing_number of this BankTransferUser.  # noqa: E501
        :type routing_number: str
        """

        self._routing_number = routing_number

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, BankTransferUser):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, BankTransferUser):
            return True

        return self.to_dict() != other.to_dict()
