# coding: utf-8

"""
    The Plaid API

    The Plaid REST API. Please see https://plaid.com/docs/api for more details.  # noqa: E501

    The version of the OpenAPI document: 2020-09-14_1.0.11
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from plaid.generated_plaid.configuration import Configuration


class InstitutionSearchRequest(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'client_id': 'str',
        'secret': 'str',
        'query': 'str',
        'products': 'list[Products]',
        'country_codes': 'list[CountryCode]',
        'options': 'InstitutionsSearchRequestOptions'
    }

    attribute_map = {
        'client_id': 'client_id',
        'secret': 'secret',
        'query': 'query',
        'products': 'products',
        'country_codes': 'country_codes',
        'options': 'options'
    }

    def __init__(self, client_id=None, secret=None, query=None, products=None, country_codes=None, options=None, local_vars_configuration=None):  # noqa: E501
        """InstitutionSearchRequest - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._client_id = None
        self._secret = None
        self._query = None
        self._products = None
        self._country_codes = None
        self._options = None
        self.discriminator = None

        self.client_id = client_id
        self.secret = secret
        self.query = query
        self.products = products
        self.country_codes = country_codes
        if options is not None:
            self.options = options

    @property
    def client_id(self):
        """Gets the client_id of this InstitutionSearchRequest.  # noqa: E501

        Your Plaid `client_id`.   # noqa: E501

        :return: The client_id of this InstitutionSearchRequest.  # noqa: E501
        :rtype: str
        """
        return self._client_id

    @client_id.setter
    def client_id(self, client_id):
        """Sets the client_id of this InstitutionSearchRequest.

        Your Plaid `client_id`.   # noqa: E501

        :param client_id: The client_id of this InstitutionSearchRequest.  # noqa: E501
        :type client_id: str
        """
        if self.local_vars_configuration.client_side_validation and client_id is None:  # noqa: E501
            raise ValueError("Invalid value for `client_id`, must not be `None`")  # noqa: E501

        self._client_id = client_id

    @property
    def secret(self):
        """Gets the secret of this InstitutionSearchRequest.  # noqa: E501

        Your Plaid API secret.   # noqa: E501

        :return: The secret of this InstitutionSearchRequest.  # noqa: E501
        :rtype: str
        """
        return self._secret

    @secret.setter
    def secret(self, secret):
        """Sets the secret of this InstitutionSearchRequest.

        Your Plaid API secret.   # noqa: E501

        :param secret: The secret of this InstitutionSearchRequest.  # noqa: E501
        :type secret: str
        """
        if self.local_vars_configuration.client_side_validation and secret is None:  # noqa: E501
            raise ValueError("Invalid value for `secret`, must not be `None`")  # noqa: E501

        self._secret = secret

    @property
    def query(self):
        """Gets the query of this InstitutionSearchRequest.  # noqa: E501

        The search query. Institutions with names matching the query are returned  # noqa: E501

        :return: The query of this InstitutionSearchRequest.  # noqa: E501
        :rtype: str
        """
        return self._query

    @query.setter
    def query(self, query):
        """Sets the query of this InstitutionSearchRequest.

        The search query. Institutions with names matching the query are returned  # noqa: E501

        :param query: The query of this InstitutionSearchRequest.  # noqa: E501
        :type query: str
        """
        if self.local_vars_configuration.client_side_validation and query is None:  # noqa: E501
            raise ValueError("Invalid value for `query`, must not be `None`")  # noqa: E501

        self._query = query

    @property
    def products(self):
        """Gets the products of this InstitutionSearchRequest.  # noqa: E501

        Filter the Institutions based on whether they support all products listed in products. Provide `null` to get institutions regardless of supported products  # noqa: E501

        :return: The products of this InstitutionSearchRequest.  # noqa: E501
        :rtype: list[Products]
        """
        return self._products

    @products.setter
    def products(self, products):
        """Sets the products of this InstitutionSearchRequest.

        Filter the Institutions based on whether they support all products listed in products. Provide `null` to get institutions regardless of supported products  # noqa: E501

        :param products: The products of this InstitutionSearchRequest.  # noqa: E501
        :type products: list[Products]
        """
        if self.local_vars_configuration.client_side_validation and products is None:  # noqa: E501
            raise ValueError("Invalid value for `products`, must not be `None`")  # noqa: E501

        self._products = products

    @property
    def country_codes(self):
        """Gets the country_codes of this InstitutionSearchRequest.  # noqa: E501

        Specify an array of Plaid-supported country codes this institution supports, using the ISO-3166-1 alpha-2 country code standard.    # noqa: E501

        :return: The country_codes of this InstitutionSearchRequest.  # noqa: E501
        :rtype: list[CountryCode]
        """
        return self._country_codes

    @country_codes.setter
    def country_codes(self, country_codes):
        """Sets the country_codes of this InstitutionSearchRequest.

        Specify an array of Plaid-supported country codes this institution supports, using the ISO-3166-1 alpha-2 country code standard.    # noqa: E501

        :param country_codes: The country_codes of this InstitutionSearchRequest.  # noqa: E501
        :type country_codes: list[CountryCode]
        """
        if self.local_vars_configuration.client_side_validation and country_codes is None:  # noqa: E501
            raise ValueError("Invalid value for `country_codes`, must not be `None`")  # noqa: E501

        self._country_codes = country_codes

    @property
    def options(self):
        """Gets the options of this InstitutionSearchRequest.  # noqa: E501


        :return: The options of this InstitutionSearchRequest.  # noqa: E501
        :rtype: InstitutionsSearchRequestOptions
        """
        return self._options

    @options.setter
    def options(self, options):
        """Sets the options of this InstitutionSearchRequest.


        :param options: The options of this InstitutionSearchRequest.  # noqa: E501
        :type options: InstitutionsSearchRequestOptions
        """

        self._options = options

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, InstitutionSearchRequest):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, InstitutionSearchRequest):
            return True

        return self.to_dict() != other.to_dict()
